# all files / bpmn-js/lib/features/modeling/behavior/util/ GeometricUtil.js

100% Statements 16/16
100% Branches 2/2
100% Functions 7/7
100% Lines 15/15

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120

    243×

    194×

    96×

    55×

    55×
    55×

    55×

    55×

    55×

    55×

    55×

    43×

    43×

    43×

    200×

     /**
     * Returns the length of a vector
     *
     * @param {Vector}
     * @return {Float}
     */
    export function vectorLength(v) {
      return Math.sqrt(Math.pow(v.x, 2) + Math.pow(v.y, 2));
    }

    /**
     * Calculates the angle between a line a the yAxis
     *
     * @param {Array}
     * @return {Float}
     */
    export function getAngle(line) {
      // return value is between 0, 180 and -180, -0
      // @janstuemmel: maybe replace return a/b with b/a
      return Math.atan((line[1].y - line[0].y) / (line[1].x - line[0].x));
    }

    /**
     * Rotates a vector by a given angle
     *
     * @param {Vector}
     * @param {Float} Angle in radians
     * @return {Vector}
     */
    export function rotateVector(vector, angle) {
      return (!angle) ? vector : {
        x: Math.cos(angle) * vector.x - Math.sin(angle) * vector.y,
        y: Math.sin(angle) * vector.x + Math.cos(angle) * vector.y
      };
    }

    /**
     * Solves a 2D equation system
     * a + r*b = c, where a,b,c are 2D vectors
     *
     * @param {Vector}
     * @param {Vector}
     * @param {Vector}
     * @return {Float}
     */
    function solveLambaSystem(a, b, c) {

      // the 2d system
      var system = [
        { n: a[0] - c[0], lambda: b[0] },
        { n: a[1] - c[1], lambda: b[1] }
      ];

      // solve
      var n = system[0].n * b[0] + system[1].n * b[1],
          l = system[0].lambda * b[0] + system[1].lambda * b[1];

      return -n/l;
    }

    /**
     * Position of perpendicular foot
     *
     * @param {Point}
     * @param [ {Point}, {Point} ] line defined throug two points
     * @return {Point} the perpendicular foot position
     */
    export function perpendicularFoot(point, line) {

      var a = line[0], b = line[1];

      // relative position of b from a
      var bd = { x: b.x - a.x, y: b.y - a.y };

      // solve equation system to the parametrized vectors param real value
      var r = solveLambaSystem([ a.x, a.y ], [ bd.x, bd.y ], [ point.x, point.y ]);

      return { x: a.x + r*bd.x, y: a.y + r*bd.y };
    }

    /**
     * Calculates the distance between a point and a line
     *
     * @param {Point}
     * @param [ {Point}, {Point} ] line defined throug two points
     * @return {Float} distance
     */
    export function getDistancePointLine(point, line) {

      var pfPoint = perpendicularFoot(point, line);

      // distance vector
      var connectionVector = {
        x: pfPoint.x - point.x,
        y: pfPoint.y - point.y
      };

      return vectorLength(connectionVector);
    }

    /**
     * Calculates the distance between two points
     *
     * @param {Point}
     * @param {Point}
     * @return {Float} distance
     */
    export function getDistancePointPoint(point1, point2) {

      return vectorLength({
        x: point1.x - point2.x,
        y: point1.y - point2.y
      });
    }